unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, minimizer, ExtCtrls, ComCtrls;

type
  TMainForm = class(TForm)
    X: TEdit;
    Y: TEdit;
    minF: TEdit;
    MBut: TButton;
    Label2: TLabel;
    Func: TComboBox;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Xmin: TEdit;
    Label7: TLabel;
    Ymin: TEdit;
    Bevel1: TBevel;
    Panel1: TPanel;
    Bevel2: TBevel;
    P: TPaintBox;
    Label1: TLabel;
    Iter: TEdit;
    Label8: TLabel;
    Met: TComboBox;
    LC: TCheckBox;
    Label9: TLabel;
    NC: TEdit;
    UD: TUpDown;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    E1: TEdit;
    E2: TEdit;
    Bevel3: TBevel;
    Button1: TButton;
    Sym: TCheckBox;
    M: TMinimizer;
    ColCh: TCheckBox;
    Button2: TButton;
    CBConstr: TCheckBox;
    Constraint: TEdit;
    Label13: TLabel;
    R: TEdit;
    Label14: TLabel;
    C: TEdit;
    procedure MButClick(Sender: TObject);
    procedure PPaint(Sender: TObject);
    procedure MIteration(f: Double; var x: array of double; n: Integer);
    procedure LCClick(Sender: TObject);
    procedure UDClick(Sender: TObject; Button: TUDBtnType);
    procedure NCChange(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure MEvaluateF(var x: array of double; var f: Double);
    procedure MEvaluateGrad(var x, res: array of Double; n: Integer);
    procedure MEvaluateHesse(var x: array of Double; var res: ppdouble;
      n: Integer);
    procedure SymClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure MEvaluateConstraint(var x: array of Double; var res: Double);
  private
  public
   dopaint : boolean;
   xp,yp : array of double;
   ff : array[1..50] of double;
   cl : array[1..50] of TColor;
   pn : integer;
   run : boolean;
   mx,my,nx,ny,fmx : double;
  end;

var
  MainForm: TMainForm;

implementation

uses shellapi, about,math;

{$R *.dfm}

procedure TMainForm.MButClick(Sender: TObject);
var xx : array [0..1] of double;
begin
 if run then
 begin
  M.Stop;
 end
 else
 begin
  xx[0] := strtofloat(X.Text);
  xx[1] := strtofloat(Y.Text);
  M.R := strtofloat(R.Text);
  M.C := strtofloat(C.Text);

  M.Constrained := CBConstr.Checked;
  if M.ConstraintCount > 0 then M.Constraint[0] := Constraint.Text
  else M.AddConstraint(Constraint.Text);
  M.Method := TMinMethod(Met.ItemIndex);
  M.Symbolic := Sym.Checked;
  M.Formula := Func.Text;
  M.Eps1 := strtofloat(e1.Text);
  M.Eps2 := strtofloat(e2.Text);
  Iter.Text := '0';
  pn := 0;
  mx := xx[0];
  nx := xx[0];
  my := xx[1];
  ny := xx[1];
  dopaint := false;

  run := true;
  MBut.Caption := 'Stop';
  fmx := M.Minimize(xx);
  minF.Text := floattostr(fmx);
  Xmin.Text := floattostr(xx[0]);
  Ymin.Text := floattostr(xx[1]);
  if not M.Constrained then Iter.Text := inttostr(M.Iteration);
  if (xx[0] <> xp[pn-1]) or (xx[1] <> yp[pn-1]) then
   MIteration(0, xx, 2);
  dopaint := true;
  MBut.Caption := 'Minimize';
  run := false;
  P.Repaint;
 end;
end;

procedure TMainForm.PPaint(Sender: TObject);
var maxx, maxy, minx, miny, d, d1, d2, d3,c0, c1, c2, c3,
    px, py : double;
    cc : boolean;
    i,j,k,cx,cy,i1,j1,n,c : integer;
    xx : array [0..1] of double;
begin
 P.Canvas.Brush.Color := clwhite;
 P.Canvas.FillRect(P.Canvas.ClipRect);
 if dopaint and LC.Checked then
 begin
  n := UD.Position;
  cc := ColCh.Checked;
  P.Canvas.Pen.Color := clblack;
  d := (mx - nx)*0.05;
  if d = 0 then d := 0.5;
  if M.Constrained then d := d+0.5;
  maxx := mx + d;
  minx := nx - d;
  d := (my - ny)*0.05;
  if d = 0 then d := 0.5;
  maxy := my + d;
  miny := ny - d;

  cx := P.Width;
  cy := P.height;

  px := (maxx - minx)/cx;
  py := (maxy - miny)/cy;

  xx[0] := minx;
  xx[1] := miny;
  d := M.F(xx);
  xx[1] := maxy;
  d1 := M.F(xx);
  if d1 > d then d := d1;
  xx[0] := maxx;
  d1 := M.F(xx);
  if d1 > d then d := d1;
  xx[1] := miny;
  d1 := M.F(xx);
  if d1 > d then d := d1;

  for i := 1 to n do
  begin
    d1 := i/n;
    ff[i] := (d - fmx)*d1*d1*d1*d1 + fmx;
    c := 128+128*(n-i) div n;
    cl[i] := RGB(c,c,c);
  end;


  for i := 0 to cx-1 do
  begin
   xx[0] := i*px + minx;
   xx[1] := cy*py + miny;
   d := M.F(xx);
   c0 := M.G(xx,0);
   xx[0] := xx[0] + px;
   d1 := M.F(xx);
   c1 := M.G(xx,0);

   for j := 0 to cy-1 do
   begin
    d3 := d;
    d2 := d1;
    c3 := c0;
    c2 := c1;
    xx[0] := xx[0]-px;
    xx[1] := xx[1] - py;
    d := M.F(xx);
    c0 := M.G(xx,0);
    xx[0] := xx[0] + px;
    d1 := M.F(xx);
    c1 := M.G(xx,0);
    c := 0;

    for k := 1 to n do
     if ((d2<ff[k]) and (ff[k] < d)) or
        ((d<ff[k]) and (ff[k] < d2)) or
        ((d1<ff[k]) and (ff[k] < d3)) or
        ((d3<ff[k]) and (ff[k] < d1)) then
     begin
      P.Canvas.Pen.Color := clBlack;
      P.Canvas.MoveTo(i,j);
      P.Canvas.LineTo(i+1,j+1);
      c := 0;
      break;
     end
     else
     if cc and (d > ff[k]) then c := k;
     if cc and (c > 0) then
     begin
      P.Canvas.Pen.Color := cl[c];
      P.Canvas.MoveTo(i,j);
      P.Canvas.LineTo(i+1,j+1);
     end;

    if M.Constrained  then
     if (min(min(c0,c1),min(c2,c3)) <= 0) and (max(max(c0,c1),max(c2,c3)) >= 0) then
     begin
       P.Canvas.Pen.Color := clRed;
       P.Canvas.MoveTo(i,j);
       P.Canvas.LineTo(i+1,j+1);
       P.Canvas.LineTo(i+1,j);
       P.Canvas.LineTo(i,j+1);
     end;

   end;
  end;

  P.Canvas.Pen.Color := clblue;
  P.Canvas.Brush.Color := clblue;
  i := trunc((xp[0] - minx)/(maxx-minx)*cx);
  j := cy - trunc((yp[0] - miny)/(maxy-miny)*cy);
  P.Canvas.Ellipse(i-2,j-2,i+3,j+3);

  for k := 1 to pn-1 do
  begin
   i1:=i;
   j1:=j;
   i := trunc((xp[k] - minx)/(maxx-minx)*cx);
   j := cy - trunc((yp[k] - miny)/(maxy-miny)*cy);
   P.Canvas.Ellipse(i-2,j-2,i+3,j+3);
   P.Canvas.MoveTo(i1,j1);
   P.Canvas.LineTo(i,j);
  end;

 end;
end;

procedure TMainForm.MIteration(f: Double; var x: array of double; n: Integer);
begin
 if pn > high(xp) then
 begin
  setlength(xp,high(xp)+10);
  setlength(yp,high(xp)+10);
 end;
 xp[pn] := x[0];
 yp[pn] := x[1];
 if mx < xp[pn] then mx := xp[pn];
 if my < yp[pn] then my := yp[pn];
 if nx > xp[pn] then nx := xp[pn];
 if ny > yp[pn] then ny := yp[pn];
 Iter.Text := floattostr(strtofloat(Iter.Text)+1);
 Application.ProcessMessages;
 inc(pn);
end;

procedure TMainForm.LCClick(Sender: TObject);
begin
 P.Repaint;
end;

procedure TMainForm.UDClick(Sender: TObject; Button: TUDBtnType);
begin
 P.Repaint;
end;

procedure TMainForm.NCChange(Sender: TObject);
begin
 P.Repaint;
end;

procedure TMainForm.Button1Click(Sender: TObject);
begin
 AboutForm.ShowModal;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
 M.ConstValue['a'] := 100; 
 M.ConstValue['b'] := 2; 
end;

procedure TMainForm.MEvaluateF(var x: array of double; var f: double);
begin
 f := 100*(x[1]-x[0]*x[0])*(x[1]-x[0]*x[0])+(1-x[0])*(1-x[0]);
end;

procedure TMainForm.MEvaluateGrad(var x, res: array of Double; n: Integer);
begin
 res[0] := -400*(x[1]-x[0]*x[0])*x[0]-2+2*x[0];
 res[1] := 200*x[1]-200*x[0]*x[0];
end;

procedure TMainForm.MEvaluateHesse(var x: array of Double;
  var res: ppdouble; n: Integer);
var H : array of array of double absolute res;
begin
 H[0,0] := 1200*x[0]*x[0]-400*x[1]+2;
 H[0,1] := -400*x[0];
 H[1,0] := H[0,1];
 H[1,1] := 200;
end;

procedure TMainForm.SymClick(Sender: TObject);
begin
 Func.Enabled := Sym.Checked;
 if Func.Enabled then Func.Color := clWindow
 else Func.Color := clBtnFace;
end;

procedure TMainForm.Button2Click(Sender: TObject);
var xx,grad : array [0..1] of double;
    hess : array of array of double;
    f : double;
begin
 xx[0] := strtofloat(X.Text);
 xx[1] := strtofloat(Y.Text);
 setlength(hess,2,2);
 M.Constrained := false;
 M.Symbolic := Sym.Checked;
 M.Formula := Func.Text;
 if M.Symbolic then M.PrepareSymbolic(mmNewton);
 f := M.F(xx);
 M.Grad(xx,grad);
 M.Hesse(xx,@(hess[0]));
 Application.MessageBox(pchar(
                'F = ' + floattostr(f)+#13#10+
                'Grad = ['+floattostr(grad[0])+', '+floattostr(grad[1])+']'#13#10+
                'Hessian = [['+floattostr(hess[0,0])+', '+floattostr(hess[0,1])+'],'+
                '['+floattostr(hess[1,0])+', '+floattostr(hess[1,1])+']]'
                ),'Result',mb_iconinformation);
end;

procedure TMainForm.MEvaluateConstraint(var x: array of Double;
  var res: Double);
begin
 res := x[0]*x[0]+x[1]*x[1]-1;
end;

end.
