//(c) Artem Parlyuk, PhD., 
// e-mail: info@artsoft.name, http://artsoft.name
//(c) Boris Y. Lemeshko, Prof., 
// Department of Applied Mathematics and Computer Science
// Novosibirsk State Technical University, 
// e-mail: heard@fpm.ami.nstu.ru


#include "minimize.hpp"

//   p  
//   p-  - 1
//         - 2
//     - 3


/* p  */

 void blisk(double x[],double xx[],int n,double a,double sag[],double *da,
		  int *is,double (*f)(double x[]));
 double blnrm(double x[],int n);
 double CGrad( double (*f)(double x[]), double x[],int n,
               int nm, double eps1, double eps2);               

/*  */

double CGrad( double (*f)(double x[]), double x[],int n,
               int nm, double eps1, double eps2)
{
 double  *df, *sag, *x1, *df1, *y;
 df = new double[n];
 sag = new double[n];
 x1 = new double[n];
 df1 = new double[n];
 y = new double[n];
 double  da, b, s, a1, s2, pp, rr, a;
 int i, itw, is, neud, ks, j;

   iteration = 0;
   minerror = 0;


  for(i=0; i<n; i++)
	 x1[i]=x[i];  /*  */
 a=(*f)(x);

L4:
        if(Minimize_callback) Minimize_callback(a, x, n);
	if((maxiteration > 0) && (iteration > maxiteration)) 
	{
	 minerror = ERR_ITER;
	 goto L50;
	}
        if(minimize_stop)
	{
	 minerror = ERR_ITER;
	 goto L50;
	}
       iteration++;
  da=0.1;
  itw=0;
  b=0.;
  (*grad)(f,x,df,n);
  s=blnrm(df,n);
L9:
 if(s==0.)  goto L50;

 for(i=0; i<n; i++)
	 sag[i]=-df[i]+b*sag[i];

 blisk(x,y,n,a,sag,&da,&is,(*f));

 if(is==1) goto L60;

 neud=0;
  for(i=0; i<n; i++)
 {
   y[i]=da*sag[i];
   x[i]+=y[i];
  }
 a1=a;
 a=(*f)(x);
 ks=0;
 itw++;
 if(
	((fabs(a1) > 1.) && (fabs((a1-a)/a1) < eps2))
	 ||
	((fabs(a1) <= 1) && (fabs(a1-a) < eps2))
   )   goto L50;

 for(i=0;i<n;i++)
	{
	 if(fabs(x[i]) > 1.)
	  {	 if(fabs(y[i]/x[i]) < eps1) ks++; }
	 else
	  {	 if(fabs(y[i]) < eps1) ks++; }
	}
 if(ks==n) goto L50;
/*    nm=3 */
 if(nm==3) goto L4;

/*    n+1  */

 if(itw>n+1) goto L4;

 if(nm==2)
 {
    pp=0;
    for(i=0; i<n; i++)
    {
    df1[i]=df[i];
    pp+=df1[i]*sag[i];
    }
 }

  (*grad)(f,x,df,n);

 if(nm==1)
 {
  s2=blnrm(df,n);
  b=s2/s;
  s=s2;
 }

 if(nm==2)
 {
    rr=0;
    for(i=0; i<n; i++)
	rr+=df[i]*(df[i]-df1[i]);
    b=-rr/pp;
  }

  goto L9;

L60:
  for(i=0; i<n; i++)
 {
   if(x1[i]!=x[i])
   {
	for(j=0; j<n; j++)
				  x1[j]=x[j];
	if(neud==1) goto L50;
	neud=1;
	goto L4;
   }
  }
L50:
 delete df;
 delete sag;
 delete x1;
 delete df1;
 delete y;
 return a;
}



 double blnrm(double x[],int n)
 {
 double s;
 int i;

 s=0.;
  for(i=0; i<n; i++)
	 s+=x[i]*x[i];
 return(s);
}

 void blisk(double x[],double xx[],int n,double a,double sag[],double *da,
		  int *is,double (*f)(double x[]))
{
 double  r, t, s;
 int  i, k;

 *is=0;

 for(i=0; i<n; i++)
   if(sag[i]!=0.) goto L32;
 *is=1;
 return;

L32:
 k=0;
 for(i=0; i<n; i++)
	 xx[i]=x[i]+*da*sag[i];
 r=(*f)(xx);
 if(a<r) goto L5;

L2:
  for(i=0; i<n; i++)
	 xx[i]=xx[i]+*da*sag[i];
 t=(*f)(xx);
 if(r<t) goto L10;
 *da*=2;
 r=t;
 goto L2;

L5:
 k++;
 *da/=2;
 t=r;
 for(i=0; i<n; i++)
	 xx[i]=x[i]+*da*sag[i];
 r=(*f)(xx);
 if( r <= a ) goto L10;
 if( k <= 20 ) goto L5;
 *is=1;
 return;

L10:
 s=a+t-2*r;
 if( s == 0. ) return;

L11:
 s=*da*(a*3+t-4*r)/(s*2);
 *da=s;
 return;

}



double Reeves(double (*f)(double x[]), double x[],int n,
            double eps1, double eps2)
{
 return CGrad(f, x, n, 1, eps1, eps2);
}            

//      

double Pshenichny(double (*f)(double x[]), double x[],int n,
            double eps1, double eps2)
{
 return CGrad(f, x, n, 2, eps1, eps2);
}            

//   

double SDescent(double (*f)(double x[]), double x[],int n,
            double eps1, double eps2)
{
 return CGrad(f, x, n, 3, eps1, eps2);
}            
