//(c) Artem Parlyuk, PhD., 
// e-mail: info@artsoft.name, http://artsoft.name
//(c) Boris Y. Lemeshko, Prof., 
// Department of Applied Mathematics and Computer Science
// Novosibirsk State Technical University, 
// e-mail: heard@fpm.ami.nstu.ru



#ifndef MINIMIZE_H
#define MINIMIZE_H
#define TRUE	1
#define FALSE	0




#define ERR_OK		0
#define ERR_ITER 	1
//#define MAX_VARS	10

#include <math.h>
//#pragma comment(lib, "minimize.lib")

extern __declspec (dllexport) int maxiteration, iteration, minerror, minimize_stop;
extern __declspec (dllexport) void (*Minimize_callback)(double, double x[], int n);

extern "C" __declspec (dllexport) void SetMaxIteration(int x);
extern "C" __declspec (dllexport) int GetMaxIteration();
extern "C" __declspec (dllexport) int GetIteration();
extern "C" __declspec (dllexport) int GetError();
extern "C" __declspec (dllexport) void StopMinimize();
extern "C" __declspec (dllexport) void AllowMinimize();
extern "C" __declspec (dllexport) void SetMinimizeCallBack(void (*callback)(double, double x[], int));
extern "C" __declspec (dllexport) void SetHesse(void (*fun)(double (*f)(double*), double*, double**, int));
extern "C" __declspec (dllexport) void SetGrad(void (*fun)(double (*f)(double*), double*, double*, int));

typedef double (*pMethod) (double (*f)(double x[]),double x[],int n,double eps, double eps1);

extern "C" __declspec (dllexport) double Restart(pMethod Method, double (*f)(double x[]),double x[],int n,double eps, double eps1);

//  
extern "C" __declspec (dllexport) double Rosen(double (*f)(double x[]),double x[],int n,
                 double eps = 1.e-8, double eps1 = 1e-8);

//   

extern "C" __declspec (dllexport) double QuasiNewton(double (*f)(double x[]),double x[],int n,
	       int param = 1, double eps1 = 1e-8, double eps2 = 1e-8);


// -p-

extern "C" __declspec (dllexport) double Davidon(double (*f)(double x[]),double x[],int n,
	       double eps1 = 1e-8, double eps2 = 1e-8);

// p

extern "C" __declspec (dllexport) double Fletcher(double (*f)(double x[]),double x[],int n,
	       double eps1 = 1e-8, double eps2 = 1e-8);

// p

extern "C" __declspec (dllexport) double Broyden(double (*f)(double x[]),double x[],int n,
	       double eps1 = 1e-8, double eps2 = 1e-8);

//   p 

extern "C" __declspec (dllexport) double CGrad( double (*f)(double x[]), double x[],int n,
               int nm = 1, double eps1 = 1e-8, double eps2 = 1e-8);

//   p-

extern "C" __declspec (dllexport) double Reeves(double (*f)(double x[]), double x[],int n,
            double eps1 = 1e-8, double eps2 = 1e-8);

//   

extern "C" __declspec (dllexport) double Pshenichny(double (*f)(double x[]), double x[],int n,
            double eps1 = 1e-8, double eps2 = 1e-8);

//   

extern "C" __declspec (dllexport) double SDescent(double (*f)(double x[]), double x[],int n,
            double eps1 = 1e-8, double eps2 = 1e-8);

// 

extern "C" __declspec (dllexport) double Newton(double (*f)(double x[]),
              double x[],int n,double eps1 = 1e-8, double eps2 = 1e-8);


//  

extern "C" __declspec (dllexport) void Grad(double (*f)(double*), double*, double*, int);

//  

extern "C" __declspec (dllexport) void Hesse(double (*f)(double*), double*, double** dx, int);

//   ,  
extern __declspec (dllexport) void (*grad)(double (*f)(double*), double*, double*, int);
//   ,   
extern "C" __declspec (dllexport) void (*hesse)(double (*f)(double*), double*, double** dx, int);

#endif